/*
 * MyScrapResults.java
 *
 * Created on March 30, 2007, 3:39 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
import javax.microedition.lcdui.*;
import java.lang.*;
/**
 *
 * @author Royden
 */


public class MyScrapResults implements CommandListener
{

    Display display;
    Form form;
    TextField scrapTF; 
    boolean remote=false;
    
    private MyScrapDisplayCanvas canvas;
    public MyScrapRecordStore msrs = new MyScrapRecordStore();
    private MyScrapEmotions mse ;
    
    private Command exitCmd, submitCmd,back,refresh;
    private Command emotionsCmd;


    public MyScrapResults(Display display)
    {
        this.display=display;
        mse = new MyScrapEmotions(this);
        
        form = new Form("Scrap Book");
        int width = form.getWidth();
        int height = form.getHeight();
        scrapTF = new TextField("Scrap Box:", null,30, 0);
        int scrapTFHeight = scrapTF.getPreferredHeight();    
        canvas = new MyScrapDisplayCanvas("Scraps",form.getWidth(),form.getHeight()+50);
        form.append(scrapTF);
        form.append(canvas);
        exitCmd = new Command("Exit", Command.EXIT, 1);
        back = new Command("Back", Command.EXIT, 1);
        submitCmd = new Command("Submit", Command.OK, 1);
        emotionsCmd = new Command("Emotions",Command.OK,2);
        refresh = new Command("Refresh",Command.OK,2);
        form.addCommand(exitCmd);
        form.addCommand(back);
        form.addCommand(submitCmd);
        form.addCommand(emotionsCmd);
        
        form.setCommandListener(this);
    }
    public void setResultsDisplay(boolean remote,String title)
    {
        this.remote=remote;
        display.setCurrent(form);
        form.setTitle(title);
        if(!remote)
        {
           form.addCommand(refresh); 
        }
        else
        {   try
            {
               form.removeCommand(refresh);
            }
            catch(Exception e){}
        }
           
       
    }
    
    public void commandAction(Command c, Displayable displayable) 
        {
             if (c == exitCmd)
             {
                 //link to main exit
             }
             else if (c == submitCmd) {
                 if(remote)
                 {
                     Scattercom.instance.btnet.sendString(NetLayer.SIGNAL_SUBMIT_SCRAP,scrapTF.getString(),Scattercom.instance.btnet.bluetoothaddress,Scattercom.instance.rprofile.bluetoothaddr);
                     scrapTF.setString("");
                 }
                 else
                 {SubmitAction();   }     
             }
             else if (c == emotionsCmd) {
                 display.setCurrent(mse.emotionList);
             }
             else if (c==back)
             {
                 display.setCurrent(Scattercom.instance.profile);
             }
             else if (c == refresh)
             {
                 AddScrap2Vector(msrs.TheMessage);
             }
        
        }
  
 //This function has the operations to be performed when submit operation is called.
        
  public void SubmitAction()       {
      
      //canvas = new MyScrapDisplayCanvas("Scraps",form.getWidth(),form.getHeight()+50);
      //form.append(canvas);
      canvas.clearResults();
      System.out.println("scrapping");
                String scrap = scrapTF.getString();
                    if ((scrap != null) && (!scrap.equals(""))) {
                     
                       msrs.WriteRec(Scattercom.instance.btnet.localName,scrap) ;
                        msrs.RecToStr();
                                           
                        AddScrap2Vector(msrs.TheMessage);
                      
                        scrapTF.setString("") ;
      
                 }
                else {
                        
                        AlertMessage("Nothing to say ? Think of something  !!"); 
                        scrapTF.setString("put your scrap here !!");
                    }   
  }
  
   public void ClearCanvas() {
       canvas.clearResults();
       
  }
   
 //This function gets scrap from TheMessage and adds it to the vector in the display canvas
 
  public void AddScrap2Vector (String msg)  {
      ClearCanvas();
      int i = 0; String scrap = "";
      while(i < msg.length()) {
          while(msg.charAt(i)!='#') {
              scrap = scrap + msg.charAt(i);
              i++;
          }
          i++;
          scrap = scrap + "#";
          canvas.addResult(scrap);
          scrap = "";
          
      }
  }   
 
        public void AlertMessage(String str) {
        
        Alert alert = new Alert("Choice",str,null, null);
        alert.setTimeout(Alert.FOREVER);
        alert.setType(AlertType.INFO);
        display.setCurrent(alert);
    }
 }